STRDUP(3)

NAME
strdup, strndup - duplicate a string

SYNOPSIS
#include <string.h>

char *strdup(const char *s);

char *strndup(const char *s, size_t size);

DESCRIPTION
The strdup() function returns a pointer to a new string which is a duplicate of the string s. Memory for the new string is obtained with malloc(3), and can be freed with free(3).

The strndup() works like strdup() but it only copies the first size bytes. It always add a NUL terminator, unlike strncpy(3).

RETURN VALUE
These functions returns a pointer to the duplicated string, or NULL if insufficient memory was available.

ERRORS

ENOMEM
    Insufficient memory available to allocate duplicate string.

CONFORMING TO
SVID 3, BSD 4.3

strndup() is a GNU extension.

SEE ALSO
calloc(3), malloc(3), realloc(3), free(3)